<template>
  <v-layout align-center justify-center row wrap color="#f6f6f6">
    <v-flex xs12 pa-1>
      <v-layout>
        <v-flex xs12>
          <div
            class="font-size-24-bold"
            style="color:#6a7d69; padding-bottom:10px;"
          >
            Paid Invoices
          </div>
        </v-flex>
      </v-layout>
      <!-- <div class="grey-lighten-text font-size-14">search by</div><br> -->
      <div>
        <!-- serach row 1 -->
        <v-layout align-center justify-start>
          <v-flex xs1 v-if="!mobileView"
            ><p class="font-size-16" style="color:#875c49;">
              Invoice No.
            </p></v-flex
          >
          <v-flex xs3 v-if="mobileView"
            ><p class="font-size-14" style="color:#875c49;">
              Invoice No.
            </p></v-flex
          >
          <v-flex xs4 pt-2 px-2 v-if="!mobileView">
            <v-text-field
              type="text"
              name="invoiceno"
              id="invoiceno"
              v-model="searchinvoiceno"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <v-flex xs9 pt-2 px-2 v-if="mobileView">
            <v-text-field
              type="text"
              name="invoiceno"
              id="invoiceno"
              v-model="searchinvoiceno"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <!-- desktop view -->
          <v-flex xs1 v-if="!mobileView"
            ><p class="font-size-16" style="color:#875c49; padding-left:10px;">
              Payment Date
            </p></v-flex
          >
          <v-flex xs2 px-2 v-if="!mobileView">
            <v-menu
              v-model="menu1"
              :close-on-content-click="false"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              min-width="290px"
              single-line
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  v-model="searchminstartdate"
                  prepend-inner-icon="event"
                  readonly
                  v-on="on"
                  solo
                  single-line
                  height="40"
                  color="black"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="searchminstartdate"
                @change="menu1 = false"
                color="#538795"
                no-title
                scrollable
              ></v-date-picker>
            </v-menu>
          </v-flex>
          <v-flex xs2 v-if="!mobileView">
            <v-menu
              v-model="menu2"
              :close-on-content-click="false"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              min-width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  v-model="searchmaxstartdate"
                  prepend-icon="mdi-minus"
                  prepend-inner-icon="event"
                  readonly
                  v-on="on"
                  solo
                  single-line
                  height="40"
                  color="black"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="searchmaxstartdate"
                @change="menu2 = false"
                color="#538795"
                no-title
                scrollable
              ></v-date-picker>
            </v-menu>
          </v-flex>
          <v-flex xs1></v-flex>
        </v-layout>
        <!-- end desktop view -->
        <!-- mobile view -->
        <!-- serach row 2 -->
        <v-layout align-center justify-start v-if="mobileView">
          <v-flex xs3
            ><p class="font-size-14" style="color:#875c49;">
              Payment Date
            </p></v-flex
          >
          <v-flex xs4>
            <v-menu
              v-model="menu1"
              :close-on-content-click="false"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              min-width="290px"
              single-line
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  class="font-size-14"
                  v-model="searchminstartdate"
                  prepend-inner-icon="event"
                  readonly
                  v-on="on"
                  solo
                  single-line
                  height="40"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="searchminstartdate"
                @change="menu1 = false"
                color="#538795"
                no-title
                scrollable
              ></v-date-picker>
            </v-menu>
          </v-flex>
          <v-flex xs5>
            <v-menu
              v-model="menu2"
              :close-on-content-click="false"
              lazy
              transition="scale-transition"
              offset-y
              full-width
              min-width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  class="font-size-14"
                  v-model="searchmaxstartdate"
                  prepend-icon="mdi-minus"
                  prepend-inner-icon="event"
                  readonly
                  v-on="on"
                  solo
                  single-line
                  height="40"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="searchmaxstartdate"
                @change="menu2 = false"
                color="#538795"
                no-title
                scrollable
              ></v-date-picker>
            </v-menu>
          </v-flex>
        </v-layout>

        <v-layout align-center justify-start v-if="mobileView">
          <v-flex xs3
            ><p class="font-size-14" style="color:#875c49;">Amount</p></v-flex
          >
          <v-flex xs4>
            <v-text-field
              name="minamount"
              id="minamount"
              v-model="searchminamount"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <v-flex xs5>
            <v-text-field
              name="maxamount"
              id="maxamount"
              prepend-icon="mdi-minus"
              v-model="searchmaxamount"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <!-- <v-flex xs6></v-flex> -->
        </v-layout>
        <v-layout align-end justify-end v-if="mobileView">
          <!-- <v-flex xs3>
            <v-btn
              flat small
              @click="exportmodal = true"
              color="grey"
              class="white--text">EXPORT
              <v-icon color="blue-grey">mdi-download</v-icon>
            </v-btn>
          </v-flex> -->
          <v-flex xs3>
            <v-btn flat small color="red" @click="clearsearch()">CLEAR</v-btn>
          </v-flex>
        </v-layout>

        <!-- end mobile screen -->
        <!-- serach row 3 -->
        <v-layout align-center justify-start v-if="!mobileView">
          <v-flex xs1
            ><p class="font-size-16" style="color:#875c49;">Amount</p></v-flex
          >
          <v-flex xs2 px-2>
            <v-text-field
              name="minamount"
              id="minamount"
              v-model="searchminamount"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <v-flex xs2>
            <v-text-field
              name="maxamount"
              id="maxamount"
              prepend-icon="mdi-minus"
              v-model="searchmaxamount"
              color="black"
              solo
              single-line
              height="40"
            ></v-text-field>
          </v-flex>
          <!-- <v-flex xs6></v-flex> -->
          <v-flex xs1></v-flex>
        </v-layout>
        <v-layout align-end justify-end v-if="!mobileView">
          <!-- <v-flex xs1 px-4>
          <v-btn
          flat small
          @click="exportmodal = true"
          color="grey"
          class="white--text">EXPORT
          <v-icon color="blue-grey">mdi-download</v-icon>
          </v-btn>
          </v-flex> -->
          <v-flex xs1 align="right" px-4>
            <v-btn flat small color="red" @click="clearsearch()">CLEAR</v-btn>
          </v-flex>
        </v-layout>
        <!-- table desktop-->
        <v-card v-if="!mobileView">
          <v-flex xs12 pa-1>
            <v-data-table
              :rows-per-page-items="rowperpage"
              class="elevation-0 mytable is-active"
              :headers="headers"
              :items="billsview"
              :search="billssearch"
              :loading="istableloading"
              id="mytable"
            >
              <template v-slot:items="props">
                <tr
                  @click="openinvoicemodal(props.item.Invoice_no)"
                  style="cursor: pointer;"
                >
                  <td style="color:#538795;">
                    <strong>{{ props.item.Invoice_no }}</strong>
                  </td>
                  <td class="text-xs-left">{{ props.item.Payment_date }}</td>
                  <td class="text-xs-right">{{ props.item.Amount }}</td>
                  <td class="text-xs-center">{{ props.item.Pay_type }}</td>
                  <td style="padding:0px 10px;" class="text-xs-center">
                    {{ props.item.Trans_ref }}
                  </td>
                </tr>
              </template>
            </v-data-table>
          </v-flex>
        </v-card>
        <!-- end table desktop-->
        <!-- table mobile-->
        <v-card class="justify-center" width="100%" v-if="mobileView">
          <v-flex xs12 pa-1>
            <v-data-table
              :rows-per-page-items="rowperpage"
              class="elevation-0 mytable is-active"
              :headers="headers"
              :items="billsview"
              :search="billssearch"
              :loading="istableloading"
              id="mytable"
            >
              <template v-slot:items="props">
                <tr
                  @click="openinvoicemodal(props.item.Invoice_no)"
                  style="cursor: pointer;"
                >
                  <td style="color:#538795;">
                    <strong>{{ props.item.Invoice_no }}</strong>
                  </td>
                  <td class="text-xs-left">{{ props.item.Payment_date }}</td>
                  <td class="text-xs-right">{{ props.item.Amount }}</td>
                  <td class="text-xs-center">{{ props.item.Pay_type }}</td>
                  <td style="padding:0px 10px;" class="text-xs-center">
                    {{ props.item.Trans_ref }}
                  </td>
                </tr>
              </template>
            </v-data-table>
          </v-flex>
        </v-card>
        <!-- end table mobile-->
      </div>
    </v-flex>
    <Invoicemodal />
    <Exportmodal />
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
import Invoicemodal from "@/components/Invoicemodal";
import Exportmodal from "@/components/Exportmodal";
import moment from "moment";
moment.locale("en");
export default {
  components: {
    Invoicemodal,
    Exportmodal
  },
  data() {
    return {
      mobileView: false,
      today: new Date(),
      month: "",
      day: "",
      year: "",
      backdate: "",
      menu1: false,
      menu2: false,
      menu3: false,
      menu4: false,
      searchinvoiceno: "",
      searchminstartdate: "",
      searchmaxstartdate: new Date().toISOString().substr(0, 10),
      searchminamount: "",
      searchmaxamount: "",
      istableloading: false,
      billssearch: "",
      custName: this.$cookies.get("custName"),
      headers: [
        { text: "Invoice No.", value: "Invoice_no" },
        { text: "Payment Date", value: "Pay_date", align: "left" },
        { text: "Amount", value: "Pay_amount", align: "right" },
        { text: "Payment Method", value: "Pay_type", align: "center" },
        { text: "Transaction Ref", value: "Trans_ref", align: "center" }
      ],
      bills: [],
      rowperpage: [
        5,
        10,
        25,
        { text: "$vuetify.dataIterator.rowsPerPageAll", value: -1 }
      ]
    };
  },
  methods: {
    openinvoicemodal(invoiceno) {
      this.currentinvoiceno = invoiceno;
      this.invoicemodal = true;
    },
    async getmybill() {
      try {
        this.istableloading = true;
        var { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/paid_invoices`,
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        this.bills = data.filter(bill => bill.status === "Success");
        if (this.role !== "Admin") {
          this.bills = this.bills.filter(
            bill => bill.Company_name === this.selectedcpn
          );
        } else {
          this.bills = this.bills.filter(
            bill => bill.Customer_name == this.custName
          );
        }
        // console.log('/paid_invoices Success: ',this.bills1);
        this.istableloading = false;
      } catch (error) {
        this.istableloading = false;
        console.log(error.message);
      }
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    clearsearch() {
      this.displayDate();
      this.searchinvoiceno = "";
      this.searchminstartdate = new Date(
        this.year,
        this.month - 5,
        this.date + 1
      )
        .toISOString()
        .substr(0, 10);
      this.searchmaxstartdate = new Date().toISOString().substr(0, 10);
      this.searchminamount = "";
      this.searchmaxamount = "";
    },
    displayDate() {
      this.year = this.today.getFullYear();
      this.month = this.today.getMonth();
      this.date = 1;
      this.searchmaxstartdate = new Date().toISOString().substr(0, 10);
      this.searchminstartdate = new Date(
        this.year,
        this.month - 5,
        this.date + 1
      )
        .toISOString()
        .substr(0, 10);
      // this.searchminstartdate = new Date('20180101').toISOString().substr(0, 10)
      // this.searchminduedate = new Date('20180101').toISOString().substr(0, 10)
    }
  },
  computed: {
    billsview() {
      if (
        this.searchminstartdate > this.searchmaxstartdate ||
        this.searchmaxstartdate < this.searchminstartdate
      ) {
        this.displayDate();
        alert("Please select date agian.");
      }
      // else if (this.searchminstartdate < this.searchmaxstartdate)
      return this.bills
        .filter(bill => {
          let conditions = [
            bill.Invoice_no.includes(this.searchinvoiceno),
            this.searchminamount
              ? Number(bill.Amount) >= this.searchminamount
              : true,
            this.searchmaxamount
              ? Number(bill.Amount) <= this.searchmaxamount
              : true,
            moment(bill.Pay_date)
              .format()
              .substr(0, 10) >= this.searchminstartdate,
            moment(bill.Pay_date)
              .format()
              .substr(0, 10) <= this.searchmaxstartdate
          ];
          return conditions.every(c => c);
        })
        .map(bill => {
          return {
            ...bill,
            Pay_type: bill.Pay_type ? bill.Pay_type : "-",
            Trans_ref: bill.Trans_ref ? bill.Trans_ref : "-",
            // Invoice_date: moment(bill.Invoice_date).format('D MMMM YYYY'),
            // DueDate: moment(bill.DueDate).format('D MMMM YYYY'),
            Payment_date: moment(bill.Pay_date).format("D MMMM YYYY"),
            Amount: this.addCommas(bill.Pay_amount.toFixed(2)) + " THB"
          };
        });
    },
    invoicemodal: sync("invoicemodal"),
    exportmodal: sync("exportmodal"),
    currentinvoiceno: sync("currentinvoiceno"),
    tokenHashTaxid: sync("tokenHashTaxid"),
    selectedcpn: sync("selectedcpn")
  },
  created() {
    this.role = this.$cookies.get("role");
    var tokenHashTaxid = this.$cookies.get("tokenHashTaxid");
    if (
      (this.role === "User" && this.$cookies.get("token")) ||
      (this.role === "Admin" && this.$cookies.get("token"))
    ) {
      this.getmybill();
    }
    this.displayDate();
    this.handleView();
    window.addEventListener("resize", this.handleView);
  },
  watch: {
    selectedcpn() {
      this.getmybill();
    },
    tokenHashTaxid(data) {
      if (data) {
        // console.log('check tokenHashTaxid: ', data)
        this.$cookies.set("token", data);
        this.getmybill();
      }
    }
  }
};
</script>

<style>
table {
  width: 10%;
}
.mytable table th {
  border-bottom: none;
  font-weight: bolder;
}
.v-text-field input {
  font-size: 0.9em;
}
.v-input__slot {
  min-height: 26px !important;
}
.v-input__icon--prepend .v-icon {
  color: black;
}
</style>
